//Copyright (c) 1997 Aidan Cully
//All rights reserved

#ifndef __NULLHANDLER_H
#define __NULLHANDLER_H

#include "CLPulsar.h"
#include "CLDeviceHandler.h"
#include "CLList.h"

class TNullHandler:
	public TDeviceHandler
{
private:
	TList<TList<MPulsar*>*> mhPulsars;
	static TNullHandler *sNullHandler;
protected:
	virtual void BuildEvent( const EventRecord& );
public:
	TNullHandler();
	virtual void NewDispatcher();
	virtual void OldDispatcher();
	virtual void DispatchEvent( const EventRecord& );
	static TNullHandler *GetNullHandler() {return( sNullHandler );};
	virtual void AddPulsar( MPulsar* );
	virtual void RemovePulsar( MPulsar* );
};

#endif