/*
 	File:		BSDOffscreenLib.h
 
 	Contains:	BSDOffscreenLib Headers.
 
 	Version:	Technology:	Torture Chamber v1.0
 				Package:	BSDOffscreenLib v1.0.2
 
 	Copyright:	 1997, BuggySoft Development.
 				By Scott Dunbar
*/

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __QDOFFSCREEN__
#include <QDOffscreen.h>
#endif

extern Pattern none;
extern GrafPtr oldPort;

extern void Window2GWorld (GrafPtr srcPort, GWorldPtr destPort, short mode);
extern void Window2GWorldRect (GrafPtr srcPort, GWorldPtr destPort, Rect srcRect, Rect destRect, short mode);
extern void Window2GWorldRgn (GrafPtr srcPort, GWorldPtr destPort, short mode, RgnHandle clip);
extern void Window2GWorldRectRgn (GrafPtr srcPort, GWorldPtr destPort, Rect srcRect, Rect destRect, short mode, RgnHandle clip);

extern void GWorld2Window (GWorldPtr srcPort, GrafPtr destPort, short mode);
extern void GWorld2WindowRect (GWorldPtr srcPort, GrafPtr destPort, Rect srcRect, Rect destRect, short mode);
extern void GWorld2WindowRgn (GWorldPtr srcPort, GrafPtr destPort, short mode, RgnHandle clip);
extern void GWorld2WindowRectRgn (GWorldPtr srcPort, GrafPtr destPort, Rect srcRect, Rect destRect, short mode, RgnHandle clip);

extern void Window2Window (GrafPtr srcPort, GrafPtr destPort, short mode);
extern void Window2WindowRect (GrafPtr srcPort, GrafPtr destPort, Rect srcRect, Rect destRect, short mode);
extern void Window2WindowRgn (GrafPtr srcPort, GrafPtr destPort, short mode, RgnHandle clip);
extern void Window2WindowRectRgn (GrafPtr srcPort, GrafPtr destPort, Rect srcRect, Rect destRect, short mode, RgnHandle clip);

extern void GWorld2GWorld (GWorldPtr srcPort, GWorldPtr destPort, short mode);
extern void GWorld2GWorldRect (GWorldPtr srcPort, GWorldPtr destPort, Rect srcRect, Rect destRect, short mode);
extern void GWorld2GWorldRgn (GWorldPtr srcPort, GWorldPtr destPort, short mode, RgnHandle clip);
extern void GWorld2GWorldRectRgn (GWorldPtr srcPort, GWorldPtr destPort, Rect srcRect, Rect destRect, short mode, RgnHandle clip);

extern void Window2GWorldMask (GrafPtr srcPort, GWorldPtr maskPort, GWorldPtr destPort, Rect srcRect, Rect destRect);
extern void Window2WindowMask (GrafPtr srcPort, GWorldPtr maskPort, GrafPtr destPort, Rect srcRect, Rect destRect);
extern void GWorld2WindowMask (GWorldPtr srcPort, GWorldPtr maskPort, GrafPtr destPort, Rect srcRect, Rect destRect);
extern void GWorld2GWorldMask (GWorldPtr srcPort, GWorldPtr maskPort, GWorldPtr destPort, Rect srcRect, Rect destRect);

extern void Screen2GWorld (GWorldPtr destPort, short mode);

extern GWorldPtr QuickGWorld (Rect rect);
extern GWorldPtr CreateGWorldEmpty (short depth, Rect rect);
extern GWorldPtr CreateGWorldPict (short depth, Rect rect, PicHandle pict);
extern GWorldPtr CreateGWorldPattern (short depth, Rect rect, Pattern pat);
extern GWorldPtr CreateGWorld (short depth, Rect rect, CTabHandle ctab, GDHandle device, GWorldFlags flags, PicHandle pict, Pattern pat);

extern void OpenGWorld (GWorldPtr gWorld);
extern void CloseGWorld (void);

#ifdef __cplusplus
}
#endif