/*	Sampling Rate	*/
/*	v 1.0			*/
/*	1996 by ANR 	*/


#include "MAD.h"
#include "PPPlug.h"

#if defined(powerc) || defined(__powerc)
enum {
		PlayerPROPlug = kCStackBased
		| RESULT_SIZE(SIZE_CODE( sizeof(OSErr)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof( sData*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof( long)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof( long)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof( PPInfoPlug*)))
};

ProcInfoType __procinfo = PlayerPROPlug;
#else
#include <A4Stuff.h>
#endif

GDHandle	TheGDevice:0xCC8;

void AutoPosition( DialogPtr aDia)
{
	
	Point	Position, mouse;
	Rect	ViewRect;
	short	XSize = (aDia->portRect.right - aDia->portRect.left), YSize = (aDia->portRect.bottom - aDia->portRect.top);
	
	
	GetMouse( &mouse);
	LocalToGlobal( &mouse);
	
	SetRect( &ViewRect, (*TheGDevice)->gdRect.left + 8, (*TheGDevice)->gdRect.top + 43,
						(*TheGDevice)->gdRect.right - 8, (*TheGDevice)->gdRect.bottom - 8);
	
	Position.h = mouse.h - XSize/2;
	if( Position.h + XSize >= ViewRect.right) Position.h = ViewRect.right - XSize;
	else if( Position.h <= ViewRect.left) Position.h = ViewRect.left;
	
	Position.v = mouse.v - YSize/2;
	if( Position.v + YSize >= ViewRect.bottom) Position.v = ViewRect.bottom - YSize;
	else if( Position.v <= ViewRect.top) Position.v = ViewRect.top;
	
	MoveWindow( aDia, Position.h, Position.v, false);
	
	ShowWindow( aDia);
}

void GetDText (DialogPtr dlog, short item, StringPtr str)
{
Handle	itemHandle;
short	itemType;
Rect	itemRect;

	GetDItem (dlog, item, &itemType, &itemHandle, &itemRect);
	GetIText (itemHandle, str);
}

void SetDText (DialogPtr dlog, short item, Str255 str)
{
Handle	itemHandle;
short	itemType;
Rect	itemRect;

	GetDItem (dlog, item, &itemType, &itemHandle, &itemRect);
	SetIText (itemHandle, str);
}

Ptr ConvertSampleC4SPD( Ptr src, long srcSize, short amp, long srcC4SPD, long dstC4SPD)
{
	#define LRVAL	4L

	short						*src16 = (short*) src, *dst16;
	char						*src8 = (char*) src, *dst8;
	Ptr							dst;
	long						newSize, temp;
	unsigned long		x, left, right, pos;
	
	newSize = (srcSize * dstC4SPD) / srcC4SPD;
	
	dst = NewPtr( newSize);
	if( dst == 0L) return 0L;
	
	dst16 = (short*) dst;
	dst8 = (char*) dst;
	
	srcC4SPD /= 100;
	dstC4SPD /= 100;
	
	switch( amp)
	{
	case 8:
		for( x = 0; x < newSize; x++)
		{
			pos			= (x * srcC4SPD << LRVAL) / dstC4SPD;
			right		= pos & ((1 << LRVAL)-1);
			left		= (1 << LRVAL) - right;
			
			temp = (left * src8[ pos >> LRVAL] + right * src8[ 1 + (pos >> LRVAL)]) >> LRVAL;
			
			dst8[ x] = temp;
		}
	break;
	
	case 16:
		for( x = 0; x < newSize/2; x++)
		{
			pos			= (x * srcC4SPD << LRVAL) / dstC4SPD;
			right		= pos & ((1 << LRVAL)-1);
			left		= (1 << LRVAL) - right;
			
			if( (pos >> LRVAL) < 0 ||  (pos >> LRVAL) > srcSize)	Debugger();
			
			temp = (left * src16[ pos >> LRVAL] + right * src16[ 1 + (pos >> LRVAL)]) >> LRVAL;
			
			dst16[ x] = temp;
		}
	break;
	}
	
	return dst;
}

OSErr main( 	sData					*theData,
							long					SelectionStart,
							long					SelectionEnd,
							PPInfoPlug				*thePPInfoPlug)
{
DialogPtr				myDia;
short						itemHit;
Str255					tStr;

#ifndef powerc
	long	oldA4 = SetCurrentA4(); 			//this call is necessary for strings in 68k code resources
#endif

	myDia = GetNewDialog( 128, 0L, (WindowPtr) -1L);
	SetPort( myDia);
	AutoPosition( myDia);
	
	/** Default values **/
	NumToString( theData->c2spd, tStr);
	SetDText( myDia, 4, tStr);
	SetDText( myDia, 7, tStr);
	
	SelIText( myDia, 7, 0, 10000);
	/********************/
	
	ReGo:
	
	do
	{
		#if defined(powerc) || defined(__powerc)
		ModalDialog( thePPInfoPlug->MyDlgFilterUPP, &itemHit);
		#else
		ModalDialog( (ModalFilterProcPtr) thePPInfoPlug->MyDlgFilterUPP, &itemHit);
		#endif
	}
	while( itemHit != 1 && itemHit != 2);
	
	if( itemHit == 1)
	{
		long	newFreq;
		Ptr		newPtr;
		
		GetDText( myDia, 7, tStr);		StringToNum( tStr, &newFreq);
		if( newFreq < 2000L || newFreq > 50000)
		{
			SysBeep( 1);
			SelIText( myDia, 7, 0, 10000);
			goto ReGo;
		}
		
		newPtr = ConvertSampleC4SPD(	theData->data,
																	theData->size,
																	theData->amp,
																	theData->c2spd,
																	newFreq);
		
		if( newPtr != 0L)
		{
			DisposPtr( theData->data);
			theData->data		= newPtr;
			theData->size		= GetPtrSize( newPtr);
			theData->c2spd	= newFreq;
		}
	}
	
	DisposDialog( myDia);

	#ifndef powerc
		SetA4( oldA4);
	#endif

	return noErr;
}