// MiscGraphics;

/*Miscellaneous utility routines that I developed while writing Solitaire House,*/
/*mostly rather simple graphic effects.*/

#include <SAT.h>

/**** Some QuickDraw-related utilities: ****/

pascal RGBColor MakeRGBColor(short r,short g,short b);
pascal short RectWidth(Rect r);
pascal short RectHeight(Rect r);

/*Is smallR completely within bigR?*/
pascal Boolean RectInsideRect(Rect smallR, Rect bigR);

/*Draw a string centered within the box.*/
pascal void StringCenter(Str255 aString, Rect box, Boolean truncate, short shadow);

/*Wipes for using as transitions after changing gSAT.offScreen.*/
pascal void WipeIn(long ticks);
pascal void WipeOut(long ticks);

/*Copy the contents of one SATPort to another.*/
pascal void CopyScreen(SATPort fromScreen, SATPort toScreen);

/*Make a zoom animation*/
pascal void ZoomRects(Rect fromRect, Rect toRect);

/*Copy srcFace to destFace. If destFace is nil, a new face is created, otherwise srcFace is*/
/*copied to the existing dstFace.*/
pascal void SATDupFace(FacePtr *destFace, FacePtr srcFace);

/**** Pattern and cursor utilities. ****/

/*These pattern utilities replaces the old ones in the SAT lib. These are much easier to use*/
/*and just as compatible. The point with them is to have glue routies that make it really*/
/*easy to stay compatible with all old Macs, even old MacPlusses!*/

pascal PixPatHandle SATGetPattern(short patID);
pascal void SATForePattern(PixPatHandle pat);
pascal void SATBackPattern(PixPatHandle pat);
pascal void SATFillRect(Rect r, PixPatHandle pat);
pascal void SATDisposePattern(PixPatHandle pat);
pascal CursHandle SATGetCursor(short id);
pascal void SATSetCursor(CursHandle curs);
pascal void SATDisposeCursor(CursHandle curs);

