// SATSetDepth
/* A unit for setting the screen depth.*/
/* It follows the usual SAT standard for backwards compatibility - i.e. does NOT*/
/* require Color QD!*/
/* If you want to check/set for the main device, pass nil for the device. That way*/
/* you can avoid all CQD-dependent calls in your own code.*/

/* Note! This unit is independent of SAT. Thus, it can NOT inform SAT of the depth switch, but*/
/* you have to do that yourself! Call SATDepthChangeTest to let SAT redraw all faces*/
/* it can. Faces created with GetFaceFromPICT and other advanced ways are your responsability*/
/* to update.*/

pascal Boolean SATHasDepth(GDHandle theDevice, short desiredDepth);
pascal short SATGetDepth(GDHandle theDevice);
pascal OSErr SATSetDepth(GDHandle theDevice, short desiredDepth);
pascal Boolean SATGetMode(GDHandle theDevice);
pascal OSErr SATSetMode(GDHandle theDevice, Boolean wantsColor);
pascal void SATRestoreDepth();

