/**********************************************************

	Copyright (c) Dale Semchishen 1997
	All Rights Reserved

	set32.h

	Description:
		Definitions for the 32 bit set manipulation library


 **********************************************************/

#ifndef __SET32__
#define __SET32__

#ifdef CPP_COMPILER
extern "C" {
#endif


/*------------------------ Types --------------------------*/

typedef UINT4  sSET32;	/* the 32 bit set */


/*------------------------ Macros -------------------------*/

#define set32_Assign( destbits, newvalue )  ((destbits) = (newvalue))

#define set32_Not( destbits )  ((destbits) ^= (~0))

#define set32_And( destbits, srcbits )  ((destbits) &= (srcbits))

#define set32_Or( destbits, srcbits )  ((destbits) |= (srcbits))

#define set32_Xor( destbits, srcbits )  ((destbits) ^= (srcbits))

#define set32_Tst( srcbits )  (srcbits)

#define set32_Set1( destbits, bitnum )  ((destbits) |= (1L << (bitnum)))

#define set32_Clr1( destbits, bitnum )  ((destbits) &= ~(1L << (bitnum)))

#define set32_Not1( destbits, bitnum )  ((destbits) ^= (1L << (bitnum)))

#define set32_Tst1( srcbits, bitnum )  ((srcbits) & (1L << (bitnum)))



/*------------------ Function Prototypes ------------------*/

BYTE set32_Count
(
    sSET32  bitset      /* I: the bitset to count the '1's of */
);


#ifdef CPP_COMPILER
}
#endif

#endif
