// =================================================================================
//	Copyright  1996 Michael Schrig
//
//	You may copy this file, rip it apart or use it in derivative work as long
//	as you don't change the original file and this message remains intact.
// =================================================================================

#include "UResourceParser.h"


UResourceParser::UResourceParser(
	const Handle inResH)
	throw()
{
	ThrowIfNil_(inResH);

	mResH = inResH;
	mOrigResState = ::HGetState(mResH);
	::HLock(mResH);
	mCursorP = *mResH;
	mEndP = mCursorP + GetHandleSize(mResH);
}

UResourceParser::~UResourceParser() throw()
{
	::HSetState(mResH, mOrigResState);
}



UResourceParser::List::List(UResourceParser *inRP)
	:	mRP(inRP)
{
	Assert_(inRP != nil);
}

UResourceParser::List::~List()
{
}

UResourceParser::ListUntilZero::ListUntilZero(UResourceParser *inRP)
	:	List(inRP)
{
}

UResourceParser::ListZeroBased::ListZeroBased(UResourceParser *inRP)
	:	List(inRP)
{
	mCount = mRP->SWRD();
}

UResourceParser::ListZeroBased::~ListZeroBased()
{
}

UResourceParser::ListOneBased::ListOneBased(UResourceParser *inRP)
	:	List(inRP)
{
	mCount = mRP->SWRD();
}

UResourceParser::ListOneBased::~ListOneBased()
{
}

UResourceParser::ListUntilEnd::ListUntilEnd(UResourceParser *inRP)
	:	List(inRP)
{
}

UResourceParser::ListUntilEnd::~ListUntilEnd()
{
}
